sub avpdaemon_scanner {
  #Kaspersky  AVPDaemonClient scanner
  &debug("antvir: starting scan of directory \"$ENV{'TMPDIR'}\"...");
  my ($start_avpdaemon_time)=[gettimeofday];
  my ($DD,$avpdaemon_status,$stop_avpdaemon_time,$avpdaemon_time);
  &debug("run $avpdaemon_binary  $ENV{'TMPDIR'} 2>&1");
  $DD=`$avpdaemon_binary  $ENV{'TMPDIR'}  2>&1`;
  $avpdaemon_status=($? >> 8);
  &debug("--output of avpdaemon was:\n$DD--");
  if ( $avpdaemon_status > 0 || ($DD =~ /Test result: 4/ && $avpdaemon_status == 0)) {
    &debug("First test Avpdaemon OK, virus found somewhere");
    if ($DD =~ /(.*)[Ii]nfected: (.*)\n/) {
      $quarantine_description=$2;
      &debug("At least one virus was found! ($quarantine_description)");
      $quarantine_event++;
      $description .= "\n---avpdaemon results ---\n$DD";
    }
    elsif ($DD =~ /(.*)[Ss]uspicion: (.*)\n/) {
      $quarantine_description=$2;
      &debug("There may be a virus! ($quarantine_description)");
      $quarantine_event++;
      $description .= "\n---avpdaemon results ---\n$DD";
    }
    elsif ($DD =~ /(.*)[Cc]orrupted:(.*)[^0]+(.*)\n/) {
      $quarantine_description=$2;
      &debug("Corrupted file in attachment ($quarantine_description)");
      $quarantine_event++;
      $description .= "\n---avpdaemon results ---\n$DD";
    } else {
      # This implies a corrupt set of DAT files or resource problems...
      # or a not running AvpDaemon
      # &tempfail("corrupt or unknown Kaspersky scanner problems - exit status $avpdaemon_status");
    }
  }
  $stop_avpdaemon_time=[gettimeofday];
  $avpdaemon_time = tv_interval ($start_avpdaemon_time, $stop_avpdaemon_time);
  &debug("avp: finished scan of dir \"$ENV{'TMPDIR'}\" in $avpdaemon_time secs");
}
