#!/usr/bin/perl

use strict;
use Getopt::Std;
use Socket;

getopts('p:d:');
use vars qw/$opt_p $opt_d/;

my ( $usage, $port, $path, $iaddr, $paddr, $proto, $output, $buffer, $command );

$|=1;

$usage = "Usage: $0 -p <port_number> -d <directory>";
$port = $opt_p || die $usage;
$path = $opt_d || die $usage;
$iaddr = inet_aton( '127.0.0.1' );
$paddr = sockaddr_in( $port, $iaddr );
$proto = getprotobyname( 'tcp' );

socket( AVGD_SOCK, PF_INET, SOCK_STREAM, $proto )
  or die "AVG Anti-Virus daemon: can not create socket \($!\)";

connect( AVGD_SOCK, $paddr )
  or die "AVG Anti-Virus daemon: can not connect to the daemon on 127.0.0.1:$port \($!\)";

$output = "";
do {
  sysread( AVGD_SOCK, $buffer, 256 ) or die "AVG Anti-Virus daemon: sysread failed \($!\)";
  $output .= $buffer;
} while ( $output !~ /220 .*\r\n$/ );

$command = "SCAN $path\r\n";

syswrite( AVGD_SOCK, $command, length( $command ) )
  or die "AVG Anti-Virus daemon: syswrite failed  \($!\)";
  
$output = "";
do {
  sysread( AVGD_SOCK, $buffer, 256 ) or die "AVG Anti-Virus daemon: sysread failed \($!\)";
  $output .= $buffer;
} while ( $output !~ /\d{3} .*\r\n$/ );

close( AVGD_SOCK ) or die "AVG Anti-Virus daemon: can not close socket \($!)";

print $output;
