#!/usr/bin/perl

use IO::Socket;
#use strict;
use Getopt::Std;

getopts('s:p:f:');
use vars qw/ $opt_s $opt_p $opt_f/;

$|=1;

my $response;
die "Usage: $0 -s <clamd_socket> -f filename\n" if ($opt_s eq "" && $opt_p eq "" );
my $sockname = $opt_s;
my $portnum = $opt_p;
my $path = $opt_f || die "Usage: $0 -s <clamd_socket> -f filename\n";
$path = "$path\n";

if ($sockname) {
  socket(\*sock, AF_UNIX, SOCK_STREAM, 0) || die "Couldn't create socket ($!)\n";
  connect(\*sock, pack_sockaddr_un $sockname) || die "Couldn't connect() to the socket ($!)\n";
  syswrite(\*sock, "PING\n",length("PING\n"));
  sysread(\*sock, $response, 256);
  close(\*sock);
  if ($response !~ /PONG/) {
    print "Error. clamd doesn't appear to respond\n";
    exit 1;
  }
  socket(\*sock, AF_UNIX, SOCK_STREAM, 0) || die "Couldn't create socket ($!)\n";
  connect(\*sock, pack_sockaddr_un $sockname) || die "Couldn't connect() to the socket ($!)\n";
  syswrite(\*sock, "SCAN $path", length("SCAN $path"));
  sysread(\*sock, $response, 256);
  close(\*sock);
} else {
  $sock = IO::Socket::INET->new(PeerAddr => 'localhost',
				 PeerPort => $portnum,
				 Proto    => 'tcp');
  syswrite($sock, "PING\n",length("PING\n"));
  sysread($sock, $response, 256);
  close($sock);
  if ($response !~ /PONG/) {
    print "Error. clamd doesn't appear to respond\n";
    exit 1;
  }
  $sock = IO::Socket::INET->new(PeerAddr => 'localhost',
				 PeerPort => $portnum,
				 Proto    => 'tcp');
  syswrite($sock, "PING\n",length("PING\n"));
  sysread($sock, $response, 256);
  close($sock);
}

chomp($response);
if ($response =~ /PONG/) { 
  $file=$path;
  $status="OK";
} else {
  $response =~ /^(.*):\s+([^\s]+)\s+([a-z]+)$/i;
  $file=$1;
  $status=$3;
  $virus=$2;
}
if ($status ne "OK")
{
        print "FILE/DIR INFECTED : [$path]\n";
	print "VIRUS FOUND   : [$virus]\n";
	print "resp=$response\n";
}
elsif ($response == -1)
{
        print "UNKNOWN STATUS: [$path]\n";
}
elsif ($response == 0)
{
        print "FILE/DIR IS CLEAN : [$path]\n";
}
else
{
        print "OOOOOUPS!     : [$path]\n";
}
